=== debian/changelog ===
hdf5 (1.8.16+docs-8build2) zesty; urgency=medium

  * No-change rebuild against libopenmpi2

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 22 Oct 2016 01:32:48 +0000

hdf5 (1.8.16+docs-8build1) zesty; urgency=medium

  * Rebuild against openmpi2.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 21 Oct 2016 21:18:02 +0200

hdf5 (1.8.16+docs-8) unstable; urgency=medium

  * Build-Depends: php-cli instead of php5-cli (closes: #821678)
  * debian/watch: use dirversionmangle to have upstream versions
    properly sorted

 -- Gilles Filippini <pini@debian.org>  Sat, 23 Apr 2016 11:43:31 +0200

hdf5 (1.8.16+docs-7) unstable; urgency=medium

  * debian/rules: fix typo preventing doc installation.

 -- Gilles Filippini <pini@debian.org>  Sat, 19 Mar 2016 16:16:53 +0100

hdf5 (1.8.16+docs-6) unstable; urgency=medium

  * Don't support openmpi on archs where it is broken: [!hppa !m68k !sh4]

 -- Gilles Filippini <pini@debian.org>  Wed, 24 Feb 2016 17:57:01 +0100

hdf5 (1.8.16+docs-5) unstable; urgency=medium

  * Build -doc package only on archs where php5-cli is available:
    [!m68k !sh4].

 -- Gilles Filippini <pini@debian.org>  Sun, 21 Feb 2016 20:56:48 +0100
