=== debian/rules ===
#!/usr/bin/make -f

# debian/rules for libhdf5,
# (c) 2001 Brian Russo, under GPL.
# (c) 2003 Josselin Mouette
# (c) 2007-2009 Francesco P. Lovergine.
# (c) 2010-2013 Sylvestre Ledru
# (c) 2014 Gilles Filippini

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

package = libhdf5
pkgversion ?= $(shell dpkg-parsechangelog | awk '/^Version:/ {print $$2}')
version ?= $(shell echo $(pkgversion) | sed 's/\([0-9\.]\)\(+docs[0-9]*\)\?-[^-]*$$/\1/')

# Get sonames from config/lt_vers.am
include config/lt_vers.am
INTERFACES := @ _CXX _F _HL _HL_CXX _F _TOOLS
istr = $(subst @,,$(interface))
$(foreach interface,$(INTERFACES),$(eval \
  SONAME$(istr) := $(shell echo $$(($(LT$(istr)_VERS_INTERFACE) - $(LT$(istr)_VERS_AGE))))))

# Informative target
sonames:
	@$(foreach interface,$(INTERFACES),echo "SONAME$(istr) = $(SONAME$(istr))" &&) true

# Targets used by helper script make-version-scripts
SONAM%: interface = $(subst SONAME,,$@)
SONAM%:
	@echo $(SONAME$(istr))

major_version = $(shell echo $(version) | cut -d. -f1,2)
serpack = $(package)-$(SONAME)
sercpppack = $(package)-cpp-$(SONAME_CXX)
openmpipack = $(package)-openmpi-$(SONAME)
mpichpack = $(package)-mpich-$(SONAME)
virtpack = $(package)-$(major_version)

DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH      ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

ifneq (,$(wildcard /usr/share/mpi-default-dev/debian_defaults))
include /usr/share/mpi-default-dev/debian_defaults 
endif
DEFAULT_MPI=$(ARCH_DEFAULT_MPI_IMPL)

# Arches to build MPI flavors on
# Setting empty OMPIARCHS and MPICHARCHS environment variables disables
# the related mpi targets
#
ARCH_FLAG=-a
# openmpi broken on archs hppa m68k sh4 (2016-02-24)
OMPIARCHS?=any !hppa !m68k !sh4
MPICHARCHS?=any

# To build for $arch there must be either "any" or "$arch" and no "!$arch"
ifneq (,$(and $(if $(filter !$(DEB_HOST_ARCH),$(OMPIARCHS)),,yes),$(or $(filter any,$(OMPIARCHS)),$(filter $(DEB_HOST_ARCH),$(OMPIARCHS)))))
build_openmpi = yes
else
build_openmpi = no
# Exclude binary openmpi packages from the build. See debhelper manpage.
# This is in case an arch is disabled with "!$arch". These strings can't
# appear in debian/control, but the build have to be disabled anyway for
# the related archs.
export DH_OPTIONS += -N$(openmpipack) -N$(openmpipack)-dbg -Nlibhdf5-openmpi-dev
endif

ifneq (,$(and $(if $(filter !$(DEB_HOST_ARCH),$(MPICHARCHS)),,yes),$(or $(filter any,$(MPICHARCHS)),$(filter $(DEB_HOST_ARCH),$(MPICHARCHS)))))
build_mpich = yes
else
build_mpich = no
# See above comment for build_openmpi
export DH_OPTIONS += -N$(mpichpack) -N$(mpichpack)-dbg -Nlibhdf5-mpich-dev
endif

ifeq ($(build_openmpi),yes)
configure_stamp_openmpi = configure-stamp-openmpi
build_stamp_openmpi = build-stamp-openmpi
install_openmpi = install-openmpi
else
configure_stamp_openmpi =
build_stamp_openmpi =
install_openmpi =
endif

ifeq ($(build_mpich),yes)
configure_stamp_mpich = configure-stamp-mpich
build_stamp_mpich = build-stamp-mpich
install_mpich = install-mpich
else
configure_stamp_mpich =
build_stamp_mpich =
install_mpich =
endif

# Don't build doc on archs where php5-cli is not available:
NODOCARCHS ?= !m68k !sh4
ifeq (,$(filter !$(DEB_HOST_ARCH),$(NODOCARCHS)))
build_stamp_doc = build-stamp-doc
install_doc = install-doc
else
build_stamp_doc =
install_doc =
export DH_OPTIONS += -Nlibhdf5-doc
endif

ifeq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
       USE_PROD = yes
else
       USE_PROD = no
endif

# export DEB_BUILD_OPTIONS="parallel=2"
#
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
endif	

CONFIGURE_FLAGS = --prefix=/usr --host=$(DEB_HOST_GNU_TYPE) \
		  --build=$(DEB_BUILD_GNU_TYPE) \
		  --mandir=\$${prefix}/share/man \
		  --with-pthread --enable-linux-lfs --enable-unsupported \
		  --enable-shared --enable-production=$(USE_PROD) \
		  --disable-sharedlib-rpath --with-zlib --with-default-api-version=v18 \
		  --with-szlib \
		  --enable-fortran --enable-fortran2003
SERIAL_FLAGS = --enable-threadsafe --enable-cxx --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) --includedir=\$${prefix}/include/hdf5/serial --with-flavor=serial
OPENMPI_FLAGS = --enable-parallel=yes --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) --includedir=\$${prefix}/include/hdf5/openmpi --with-flavor=openmpi
MPICH_FLAGS = --enable-parallel=yes --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) --includedir=\$${prefix}/include/hdf5/mpich --with-flavor=mpich

configure: configure-stamp-debian configure-stamp \
	   $(configure_stamp_openmpi) $(configure_stamp_mpich)

configure-stamp-debian: debian/control.in
	# This loop generates helper files from debian/*.*.in templates
	cd debian && for file in *.*.in; do \
	  for flavor in serial openmpi mpich; do \
	    helper=`basename $$file .in | sed 's/soname_cxx/$(SONAME_CXX)/g;s/soname/$(SONAME)/g'` ; \
	    flavorpkgstr="" ; \
	    flavorlibstr="" ; \
	    ifmpi="#"; \
	    ifserial=""; \
	    if [ "$$flavor" != "serial" ]; then \
	      if echo "$$helper" | grep -Eq '\-cpp'; then \
	        continue ; \
	      fi ; \
	      flavorpkgstr="-$$flavor" ; \
	      ifmpi="" ; \
	      ifserial="#"; \
	    fi ; \
	    flavorlibstr="_$$flavor" ; \
	    helper=`echo $$helper | sed 's/-flavor/'$$flavorpkgstr'/'` ; \
	    sed -e 's/@FLAVORLIB@/'$$flavorlibstr'/g' \
		-e 's/@FLAVORPKG@/'$$flavorpkgstr'/g' \
		-e 's/@FLAVOR@/'$$flavor'/g' \
                -e 's/@IFMPI@/'$$ifmpi'/g' \
                -e 's/@IFSERIAL@/'$$ifserial'/g' \
                -e 's/@MULTIARCH@/$(DEB_HOST_MULTIARCH)/g' \
                -e 's/@SONAME_CXX@/$(SONAME_CXX)/g' \
                -e 's/@SONAME@/$(SONAME)/g' \
	      $$file >$$helper ; \
	    done ; \
	  done
	#
	mkdir -p m4
	dh_autoreconf
	touch $@

configure-stamp: configure-stamp-debian
	dh_testdir
	-mkdir debian/build
# configure serial version
	cd debian/build && CFLAGS="$(CFLAGS)" CXXFLAGS="$(CXXFLAGS)" FFLAGS="$(FFLAGS)" CC=/usr/bin/cc CXX=/usr/bin/c++ FC=gfortran \
		H5_LDFLAGS="-Wl,--version-script,\$$(top_srcdir)/debian/map_serial.ver" \
		../../configure $(CONFIGURE_FLAGS) $(SERIAL_FLAGS) || { cat config.log; exit 1; }
	touch $@

configure-stamp-openmpi: configure-stamp-debian
	dh_testdir
	-mkdir debian/build-openmpi
# configure version with openmpi
	cd debian/build-openmpi && CFLAGS="$(CFLAGS)" CXXFLAGS="$(CXXFLAGS)" FFLAGS="$(FFLAGS)" \
		H5_LDFLAGS="-Wl,--version-script,\$$(top_srcdir)/debian/map_mpi.ver" \
		CC=mpicc.openmpi FC=mpif90.openmpi F9X=mpif90.openmpi RUNPARALLEL=/usr/bin/mpirun.openmpi \
		OMPI_MCA_disable_memory_allocator=1 ../../configure $(CONFIGURE_FLAGS) $(OPENMPI_FLAGS) \
		|| { cat config.log; exit 1; }
	ln debian/man/h5pcc.1 debian/man/h5pcc.openmpi.1
	ln debian/man/h5pfc.1 debian/man/h5pfc.openmpi.1
	touch $@

configure-stamp-mpich: configure-stamp-debian
	dh_testdir
	-mkdir debian/build-mpich
# configure version with mpich
	cd debian/build-mpich && CFLAGS="$(CFLAGS)" CXXFLAGS="$(CXXFLAGS)" FFLAGS="$(FFLAGS)" \
		H5_LDFLAGS="-Wl,--version-script,\$$(top_srcdir)/debian/map_mpi.ver" \
		CC=mpicc.mpich \
		CXX=mpicxx.mpich FC=mpif90.mpich F9X=mpif90.mpich RUNPARALLEL=/usr/bin/mpirun.mpich \
		../../configure $(CONFIGURE_FLAGS) $(MPICH_FLAGS) \
		|| { cat config.log; exit 1; }
	ln debian/man/h5pcc.1 debian/man/h5pcc.mpich.1
	ln debian/man/h5pfc.1 debian/man/h5pfc.mpich.1
	touch $@

prep: 
	dh_prep


build: build-arch build-indep
build-arch: build-stamp $(build_stamp_openmpi) $(build_stamp_mpich)
build-indep: $(build_stamp_doc)

build-stamp: configure-stamp
	dh_testdir
	$(MAKE) $(MAKEFLAGS) -C debian/build/
	touch $@

build-stamp-openmpi: configure-stamp-openmpi 
	dh_testdir
